#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct FrequencyPlotTypeCpsd {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::compute::api::StftOptions>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "stftOptions", skip_serializing_if = "Option::is_none", default)]
    stft_options: Option<Box<super::super::super::compute::api::StftOptions>>,
    #[builder(default, into)]
    #[serde(
        rename = "magnitudeScaling",
        skip_serializing_if = "Option::is_none",
        default
    )]
    magnitude_scaling: Option<super::super::super::compute::api::MagnitudeScaling>,
    #[builder(default, into)]
    #[serde(
        rename = "outputFrequencyType",
        skip_serializing_if = "Option::is_none",
        default
    )]
    output_frequency_type: Option<
        super::super::super::compute::api::OutputFrequencyType,
    >,
    #[builder(default, into)]
    #[serde(rename = "unwrapPhase", skip_serializing_if = "Option::is_none", default)]
    unwrap_phase: Option<bool>,
    #[builder(default, into)]
    #[serde(
        rename = "outputPhaseUnit",
        skip_serializing_if = "Option::is_none",
        default
    )]
    output_phase_unit: Option<super::super::super::compute::api::OutputPhaseUnit>,
    #[builder(default, into)]
    #[serde(rename = "displayMode", skip_serializing_if = "Option::is_none", default)]
    display_mode: Option<super::MagnitudeAndPhaseDisplayMode>,
}
impl FrequencyPlotTypeCpsd {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn stft_options(
        &self,
    ) -> Option<&super::super::super::compute::api::StftOptions> {
        self.stft_options.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn magnitude_scaling(
        &self,
    ) -> Option<&super::super::super::compute::api::MagnitudeScaling> {
        self.magnitude_scaling.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn output_frequency_type(
        &self,
    ) -> Option<&super::super::super::compute::api::OutputFrequencyType> {
        self.output_frequency_type.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn unwrap_phase(&self) -> Option<bool> {
        self.unwrap_phase.as_ref().map(|o| *o)
    }
    #[inline]
    pub fn output_phase_unit(
        &self,
    ) -> Option<&super::super::super::compute::api::OutputPhaseUnit> {
        self.output_phase_unit.as_ref().map(|o| &*o)
    }
    /// Whether to the magnitude or phase of the output. Defaults to MAGNITUDE if not specified.
    #[inline]
    pub fn display_mode(&self) -> Option<&super::MagnitudeAndPhaseDisplayMode> {
        self.display_mode.as_ref().map(|o| &*o)
    }
}
